import React from 'react';
import SwiperComponent from '../../components/CommonComponent/SwiperComponent/SwiperComponent'
import TroubleItem from '../../components/TroubleComponent/TroubleItemComponent/TroubleItemComponent'
import Button from '../../components/CommonComponent/ButtonComponent/ButtonComponent'
import HeaderComponent from '../../components/CommonComponent/HeaderComponent/HeaderComponent'
import TextArea from "../TextAreaContainer/TextAreaContainer";
import FinishTrouble from '../../components/TroubleComponent/FinishTroubleComponent/FinishTroubleComponent'
require('./index.css')
export default class TroubleContainer extends React.Component{
    constructor(props){
        super(props);
        this.state = {
            showTrouble : true,
            troubleList : {},
            currentErrorCode : 0,
            showTextArea : false,
            tmpText : ''
        };
        this.setItem = this.setItem.bind(this);
        this.showText = this.showText.bind(this);
        this.goBack = this.goBack.bind(this);
        this.saveText = this.saveText.bind(this);
    }



    dealTrouble(){
        let {showPopup,hidePopup} = this.props;
        let troubleList = this.state.troubleList;
        let details = troubleList.details;
        let arr = details.filter(d=>{
            return ! d.isExistProblem || ! d.explanation
        });

        if(arr && arr.length > 0){
            showPopup({
                popupText:'请完成所有需要处理的故障的必填项',
                popupButtons:[{text : '关闭',option:hidePopup}]
            })
        }else{
            details.forEach((d)=>{
                d.imagesFileId = d.files.map(f=>f.id).join(',');
            });
            this.setState({
                showTrouble : false
            })
        }
    }


    componentWillMount(){
        let {initTroubleList} = this.props;
        initTroubleList();
    }

    componentWillReceiveProps(nextProps){
        let troubleList = nextProps.troubleList;
        let nowTroubleList = this.state.troubleList;
        let troubleErrorCodeList = Array.isArray(troubleList.details) ? troubleList.details.map(i=>i.errorCode) : []
        let nowtroubleErrorCodeList = Array.isArray(nowTroubleList.details) ? nowTroubleList.details.map(i=>i.errorCode) : []
        
        //上一次和这一次不一样
        let troubleErrorCodeListStr = troubleErrorCodeList.join(",");
        let nowtroubleErrorCodeListStr = nowtroubleErrorCodeList.join(",");

        if(
            troubleErrorCodeListStr !== nowtroubleErrorCodeListStr
        ){
            this.setState({
                troubleList : troubleList
            })
        }

    }

    showText(errcode){
        console.log("errcode ",errcode)
        let troubleList = this.state.troubleList;
        let details = troubleList.details;
        let index = details.findIndex(d=>d.errorCode === errcode);
        if(index > -1){
            let text = details[index]['explanation'];
            console.log("text ",text)
            this.setState({
                currentErrorCode : errcode,
                showTextArea : true,
                tmpText: text
            })
        }


    }

    setItem(errcode,option,info){
        let troubleList = this.state.troubleList;
        let details = troubleList.details;
        let index = details.findIndex(d=>d.errorCode === errcode);
        if(index > -1){
            details[index][option] = info;
        }
        this.setState({
            troubleList : troubleList,
        },()=>{
            this.goBack()
        })
    }
    saveText(text){
        let errcode = this.state.currentErrorCode;
        this.setItem(errcode,'explanation',text);

    }


    goBack(){
        this.setState({
            currentErrorCode : 0,
            showTextArea : false,
            tmpText: ''
        })
    }


    render(){

        let {userInfo,storeInfo} = this.props;
        let troubleList = this.state.troubleList;
        let showTrouble = Array.isArray(troubleList.details) && troubleList.details.length > 0;
        let details = Array.isArray(troubleList.details) ? troubleList.details : [];
        let dom = details.map((i,k)=>{
            return <TroubleItem key={k} item={i} num={k+1} setItem={this.setItem} showText={this.showText}/>;
        });
        let swiperOptions = {
            width : 1396,
            spaceBetween: 30,
            freeMode:true,
        };
        let swiperContainer = CONFIG.swiperContainers.troubleSwiperContainer;
        let swiperCount = details.length;
        return (
            <div className={"troubleContainers "+(this.state.showTextArea ? 'backfff' : '')}>
                {
                    this.state.showTextArea ? <TextArea
                            text={this.state.tmpText}
                            goBack={this.goBack}
                            saveText={this.saveText}
                        ></TextArea> :
                        <div className={"toubleContainer " + (showTrouble ? '' : 'hide')}>
                            <HeaderComponent
                                showHeader={CONFIG.headerStatus[1]}
                                userinfo={userInfo}
                                storeInfo={storeInfo}
                            />

                            {
                                this.state.showTrouble ?
                                    <div className={"troubleContent " + ( this.state.showTrouble ? '' : 'hide')}>
                                        <div className={"troubleText font32"}><span className={"colff7860"}>* </span>必填项</div>
                                        <div className={"troubleBox"}>
                                            <SwiperComponent
                                                swiperContainer={swiperContainer} swiperOptions={swiperOptions} swiperCount={swiperCount}
                                            >
                                                {dom}
                                            </SwiperComponent>
                                        </div>
                                        <div className={"troubleBtnBox"}>
                                            <div className={"troubleBtn colfff font32"} onClick={()=>this.dealTrouble.bind(this)()}>
                                                处理完毕
                                            </div>
                                        </div>

                                    </div> : <FinishTrouble />
                            }
                        </div>
                }
            </div>
        )
    }
}